Index: lemon/CMakeLists.txt
===================================================================
--- lemon/CMakeLists.txt	(revision 141)
+++ lemon/CMakeLists.txt	(revision 225)
@@ -1,2 +1,18 @@
-include_directories (${LEMON_SOURCE_DIR})
-add_library (lemon arg_parser.cc base.cc color.cc random.cc)
+INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
+
+ADD_LIBRARY(lemon
+  arg_parser.cc
+  base.cc
+  color.cc
+  random.cc)
+
+INSTALL(
+  TARGETS lemon
+  ARCHIVE DESTINATION lib
+  COMPONENT library)
+
+INSTALL(
+  DIRECTORY . bits concepts
+  DESTINATION include/lemon
+  COMPONENT headers
+  FILES_MATCHING PATTERN "*.h")
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 195)
+++ lemon/Makefile.am	(revision 220)
@@ -25,4 +25,5 @@
 	lemon/concept_check.h \
         lemon/counter.h \
+	lemon/core.h \
         lemon/dfs.h \
         lemon/dijkstra.h \
@@ -30,5 +31,4 @@
 	lemon/error.h \
         lemon/graph_to_eps.h \
-	lemon/graph_utils.h \
 	lemon/kruskal.h \
 	lemon/lgf_reader.h \
@@ -50,10 +50,9 @@
         lemon/bits/bezier.h \
 	lemon/bits/default_map.h \
+        lemon/bits/enable_if.h \
 	lemon/bits/graph_extender.h \
-        lemon/bits/invalid.h \
 	lemon/bits/map_extender.h \
 	lemon/bits/path_dump.h \
 	lemon/bits/traits.h \
-        lemon/bits/utility.h \
 	lemon/bits/vector_map.h
 
Index: lemon/assert.h
===================================================================
--- lemon/assert.h	(revision 212)
+++ lemon/assert.h	(revision 218)
@@ -238,5 +238,5 @@
 
 #    if LEMON_ENABLE_DEBUG
-#      define LEMON_DEBUG(exp, msg)
+#      define LEMON_DEBUG(exp, msg)                                     \
          (static_cast<void> (!!(exp) ? 0 : (                            \
            LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                     \
Index: lemon/base.cc
===================================================================
--- lemon/base.cc	(revision 209)
+++ lemon/base.cc	(revision 220)
@@ -21,5 +21,5 @@
 
 #include<lemon/tolerance.h>
-#include<lemon/bits/invalid.h>
+#include<lemon/core.h>
 namespace lemon {
 
Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 244)
+++ lemon/bfs.h	(revision 247)
@@ -25,7 +25,6 @@
 
 #include <lemon/list_graph.h>
-#include <lemon/graph_utils.h>
 #include <lemon/bits/path_dump.h>
-#include <lemon/bits/invalid.h>
+#include <lemon/core.h>
 #include <lemon/error.h>
 #include <lemon/maps.h>
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 209)
+++ lemon/bits/alteration_notifier.h	(revision 236)
@@ -23,5 +23,5 @@
 #include <list>
 
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 
 ///\ingroup graphbits
@@ -42,5 +42,5 @@
   ///
   /// The graph's node and edge sets can be changed as we add or erase
-  /// nodes and edges in the graph. Lemon would like to handle easily
+  /// nodes and edges in the graph. LEMON would like to handle easily
   /// that the node and edge maps should contain values for all nodes or
   /// edges. If we want to check on every indicing if the map contains
@@ -410,7 +410,7 @@
           ++it;
         } catch (const ImmediateDetach&) {
-          it = _observers.erase(it);
           (*it)->_index = _observers.end();
           (*it)->_notifier = 0;
+          it = _observers.erase(it);
         }
       }
@@ -430,7 +430,7 @@
           ++it;
         } catch (const ImmediateDetach&) {
-          it = _observers.erase(it);
           (*it)->_index = _observers.end();
           (*it)->_notifier = 0;
+          it = _observers.erase(it);
         }
       }
@@ -469,7 +469,7 @@
           ++it;
         } catch (const ImmediateDetach&) {
-          it = _observers.erase(it);
           (*it)->_index = _observers.end();
           (*it)->_notifier = 0;
+          it = _observers.erase(it);
         }
       }
Index: lemon/bits/base_extender.h
===================================================================
--- lemon/bits/base_extender.h	(revision 209)
+++ lemon/bits/base_extender.h	(revision 220)
@@ -20,5 +20,5 @@
 #define LEMON_BITS_BASE_EXTENDER_H
 
-#include <lemon/bits/invalid.h>
+#include <lemon/core.h>
 #include <lemon/error.h>
 
Index: lemon/bits/enable_if.h
===================================================================
--- lemon/bits/enable_if.h	(revision 220)
+++ lemon/bits/enable_if.h	(revision 220)
@@ -0,0 +1,131 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+// This file contains a modified version of the enable_if library from BOOST.
+// See the appropriate copyright notice below.
+
+// Boost enable_if library
+
+// Copyright 2003 (c) The Trustees of Indiana University.
+
+// Use, modification, and distribution is subject to the Boost Software
+// License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
+// http://www.boost.org/LICENSE_1_0.txt)
+
+//    Authors: Jaakko Jarvi (jajarvi at osl.iu.edu)
+//             Jeremiah Willcock (jewillco at osl.iu.edu)
+//             Andrew Lumsdaine (lums at osl.iu.edu)
+
+
+#ifndef LEMON_BITS_ENABLE_IF_H
+#define LEMON_BITS_ENABLE_IF_H
+
+///\file
+///\brief Miscellaneous basic utilities
+
+namespace lemon
+{
+
+  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
+
+  /// Basic type for defining "tags". A "YES" condition for \c enable_if.
+  ///
+  ///\sa False
+  struct True {
+    ///\e
+    static const bool value = true;
+  };
+
+  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
+
+  /// Basic type for defining "tags". A "NO" condition for \c enable_if.
+  ///
+  ///\sa True
+  struct False {
+    ///\e
+    static const bool value = false;
+  };
+
+
+
+  template <typename T>
+  struct Wrap {
+    const T &value;
+    Wrap(const T &t) : value(t) {}
+  };
+
+  /**************** dummy class to avoid ambiguity ****************/
+
+  template<int T> struct dummy { dummy(int) {} };
+
+  /**************** enable_if from BOOST ****************/
+
+  template <typename Type, typename T = void>
+  struct exists {
+    typedef T type;
+  };
+
+
+  template <bool B, class T = void>
+  struct enable_if_c {
+    typedef T type;
+  };
+
+  template <class T>
+  struct enable_if_c<false, T> {};
+
+  template <class Cond, class T = void>
+  struct enable_if : public enable_if_c<Cond::value, T> {};
+
+  template <bool B, class T>
+  struct lazy_enable_if_c {
+    typedef typename T::type type;
+  };
+
+  template <class T>
+  struct lazy_enable_if_c<false, T> {};
+
+  template <class Cond, class T>
+  struct lazy_enable_if : public lazy_enable_if_c<Cond::value, T> {};
+
+
+  template <bool B, class T = void>
+  struct disable_if_c {
+    typedef T type;
+  };
+
+  template <class T>
+  struct disable_if_c<true, T> {};
+
+  template <class Cond, class T = void>
+  struct disable_if : public disable_if_c<Cond::value, T> {};
+
+  template <bool B, class T>
+  struct lazy_disable_if_c {
+    typedef typename T::type type;
+  };
+
+  template <class T>
+  struct lazy_disable_if_c<true, T> {};
+
+  template <class Cond, class T>
+  struct lazy_disable_if : public lazy_disable_if_c<Cond::value, T> {};
+
+} // namespace lemon
+
+#endif
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 209)
+++ lemon/bits/graph_extender.h	(revision 220)
@@ -20,6 +20,5 @@
 #define LEMON_BITS_GRAPH_EXTENDER_H
 
-#include <lemon/bits/invalid.h>
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 
 #include <lemon/bits/map_extender.h>
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 209)
+++ lemon/bits/traits.h	(revision 220)
@@ -20,11 +20,14 @@
 #define LEMON_BITS_TRAITS_H
 
-#include <lemon/bits/utility.h>
-
 ///\file
 ///\brief Traits for graphs and maps
 ///
 
+#include <lemon/bits/enable_if.h>
+
 namespace lemon {
+
+  struct InvalidType {};
+
   template <typename _Graph, typename _Item>
   class ItemSetTraits {};
Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 209)
+++ lemon/bits/vector_map.h	(revision 220)
@@ -23,7 +23,5 @@
 #include <algorithm>
 
-#include <lemon/bits/traits.h>
-#include <lemon/bits/utility.h>
-
+#include <lemon/core.h>
 #include <lemon/bits/alteration_notifier.h>
 
Index: lemon/concepts/digraph.h
===================================================================
--- lemon/concepts/digraph.h	(revision 209)
+++ lemon/concepts/digraph.h	(revision 220)
@@ -24,6 +24,5 @@
 ///\brief The concept of directed graphs.
 
-#include <lemon/bits/invalid.h>
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 #include <lemon/concepts/maps.h>
 #include <lemon/concept_check.h>
Index: lemon/concepts/graph.h
===================================================================
--- lemon/concepts/graph.h	(revision 209)
+++ lemon/concepts/graph.h	(revision 220)
@@ -26,5 +26,5 @@
 #include <lemon/concepts/graph_components.h>
 #include <lemon/concepts/graph.h>
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 
 namespace lemon {
Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 209)
+++ lemon/concepts/graph_components.h	(revision 220)
@@ -25,5 +25,5 @@
 #define LEMON_CONCEPT_GRAPH_COMPONENTS_H
 
-#include <lemon/bits/invalid.h>
+#include <lemon/core.h>
 #include <lemon/concepts/maps.h>
 
Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 209)
+++ lemon/concepts/heap.h	(revision 220)
@@ -24,5 +24,5 @@
 #define LEMON_CONCEPT_HEAP_H
 
-#include <lemon/bits/invalid.h>
+#include <lemon/core.h>
 
 namespace lemon {
Index: lemon/concepts/maps.h
===================================================================
--- lemon/concepts/maps.h	(revision 210)
+++ lemon/concepts/maps.h	(revision 220)
@@ -20,5 +20,5 @@
 #define LEMON_CONCEPT_MAPS_H
 
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 #include <lemon/concept_check.h>
 
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 212)
+++ lemon/concepts/path.h	(revision 236)
@@ -26,6 +26,5 @@
 #define LEMON_CONCEPT_PATH_H
 
-#include <lemon/bits/invalid.h>
-#include <lemon/bits/utility.h>
+#include <lemon/core.h>
 #include <lemon/concept_check.h>
 
@@ -79,5 +78,5 @@
       void clear() {}
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths.
@@ -202,5 +201,5 @@
     /// If we would like to give back a real path from these
     /// algorithms then we should create a temporarly path object. In
-    /// Lemon such algorithms gives back a path dumper what can
+    /// LEMON such algorithms gives back a path dumper what can
     /// assigned to a real path and the dumpers can be implemented as
     /// an adaptor class to the predecessor map.
@@ -234,5 +233,5 @@
       typedef False RevPathTag;
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths.
@@ -261,5 +260,5 @@
       };
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths in
